var _ver = getVersion();
var _textContent = _ver.ie ? "innerText" : "textContent";
var _id = getID();

function getVersion() {
    var nu = navigator.userAgent;
    var rv = {
        ie:     !!document.uniqueID,
        gecko:  nu.indexOf("Gecko/") > 0,
        webkit: nu.indexOf("WebKit") > 0,
        chrome: nu.indexOf("Chrome") > 0,
        iphone: /iPad|iPod|iPhone/.test(nu),
        opera:  !!window.opera,
        ua:     window.opera ? +(window.opera.version().replace(/\d$/, ""))
                             : parseFloat((/(?:IE |fox\/|ome\/|ion\/)(\d+\.\d)/.
                                          exec(nu) || [,0])[1]),
        re:     parseFloat(((/(?:rv\:|ari\/|sto\/)(\d+\.\d+(\.\d+)?)/.
                    exec(nu) || [,0])[1]).toString().replace(/[^\d\.]/g, "").
                    replace(/^(\d+\.\d+)(\.(\d+))?$/,"$1$3"))
    };
    if (rv.ie) {
        if (rv.ua === 6) {
            rv.ie6 = true;
        }
        if (rv.ua === 7) {
            rv.ie7 = true;
        }
        if (rv.ua === 8) {
            rv.ie8 = true;
        }

        if (rv.ie6 || rv.ie7) {
            rv.ie67 = true;
        }
        if (rv.ie6 || rv.ie7 || rv.ie8) {
            rv.ie678 = true;
        }
    }
    rv.jit   = (rv.ie     && rv.ua >= 9)   || // IE 9+
               (rv.gecko  && rv.re >  1.9) || // Firefox 3.5+(1.91)
               (rv.webkit && rv.re >= 528) || // Safari 4+, Google Chrome 2+
               (rv.opera  && rv.ua >= 10.5);  // Opera10.50+
    return rv;
}

function getID() {
    var rv = "unknown";

    if (_ver.gecko && _ver.re === 1.92) {
        rv = "Fx3.6";
    } else if (_ver.iphone) {
        rv = "iPhone";
    } else if (_ver.chrome) {
        rv = "GC" + _ver.ua;
    } else if (_ver.webkit) {
        rv = "Sa" + _ver.ua;
    } else if (_ver.opera && _ver.ua === 10.6) {
        rv = "Op10.6x";
    } else if (_ver.ie && _ver.ua === 6) {
        rv = "IE6";
    } else if (_ver.ie && _ver.ua === 7) {
        rv = "IE7";
    } else if (_ver.ie && _ver.ua === 8) {
        rv = "IE8";
    } else if (_ver.ie && _ver.ua === 9) {
        rv = "IE9";
    }
    return rv;
}

function getLoop() {
    var loop = 10000; // rate 1 = 10000

    if (_ver.iphone) {
        ;
    } else if (_ver.jit) {
        loop *= 100;  // rate 100 = 10000 * 100 = 1000000
    } else {
        loop *= 10; // rate 10 = 10000 * 10 = 100000
    }
    return loop;
}

var _head = [], _data = [], _func = [];
var _stock = {};
var _retry = 0; // リトライカウンター

// benchmark
function job(times, loop, ary, next, data1, data2, data3, data4) {
    _head = [], _data = [], _retry = 0; // reset

    function jobcall() {
        if (!ary.length) {
            if (!next) {
                fin();
            } else {
                next();
            }
            return;
        }
        var title = ary.shift();
        var fn = ary.shift();

        _head.push(title);
        _func.push(fn.toString());

        // タイトルが同じで
        // ストック済のデータがある場合は、ベンチマークを取り直さない
        if (title in _stock && _stock.hasOwnProperty(title)) {
            _data.push(_stock[title]);

            if (_data.length >= 2) {
                dump();
                _head = [];
                _data = [];
            }
            setTimeout(jobcall, 500);
        } else {
            setTimeout(function() {
                if (trytimes(title, fn, times, loop, ary, next, data1, data2, data3, data4)) {
                    if (_data.length >= 2) {
                        dump();
                        _head = [];
                        _data = [];
                    }
                    setTimeout(jobcall, 500);
                } else {
                    ++_retry;
                    if (_retry >= 5) {
                        document.body.innerHTML += "x";
                        return; // 強制終了
                    }
                    // リトライ
                    setTimeout(arguments.callee, 0);
                }
            }, 0);
        }
    }
    setTimeout(jobcall, 500);
}

// 数回試行し、両端1回分のデータを捨て、平均値を_dataに追加
function trytimes(title, fn, times, loop, ary, next, data1, data2, data3, data4) {
    var i = 0, sample = [];
    var tm = 0;
    for (; i < times; ++i) {
        document.body.innerHTML += ".";

        tm = bench(loop, fn, data1, data2, data3, data4);
        // Firefoxのタイマーは不安定
        // 経過時間にマイナスを返した場合はリトライする
        if (tm < 0) {
            document.body.innerHTML += "T";
            --i; // retry
            continue;
        }
        sample.push(tm);
    }
    // サンプル数が3以上なら両端のデータを捨てる
    if (sample.length >= 3) {
        sample.sort();

        // 最速と最遅で2倍以上の開きがあるなら、データは無効
        // Firefoxで特に発生するデータの偏りを捨てる
        if ((sample[sample.length - 1] >= sample[0] * 2) && sample[0] > 0) {
            document.body.innerHTML += "!";
            return false; // ERROR
        } else {
            sample.shift();
            sample.pop();
            _data.push(Math.floor((sample[0] + sample[1] + sample[2]) / 3));
        }
    } else { // サンプル数が3未満なら先頭のデータを採用
        _data.push(sample[0]);
    }
    _stock[title] = _data[_data.length - 1];
    return true; // OK
}

function bench(loop,
               fn,
               data1,
               data2,
               data3,
               data4) {
    var now = +new Date, idx = 0;
    var n = 0;

    for (; idx < loop; ++idx) {
        n += fn(idx, data1, data2, data3, data4);
    }
    return (+new Date) - now;
}

// dump score
function dump() {
    var ratio = Math.round((_data[0] / _data[1]) * 100);

    _head.unshift("ratio");
    _data.unshift((isNaN(ratio) || !isFinite(ratio)) ? "ERROR" : (ratio + "%")); // [NaN] division by zero

    document.body.innerHTML +=
        '<table rules="all" style="border: 1px solid gray">' +
            "<thead><tr><th>"+    "</th><th>" + _head.join("</th><th>") + "</th></tr></thead>" +
            "<tbody><tr><td>"+_id+"</td><td>" + _data.join("</td><td>") + "</td></tr></tbody>" +
        "</table>";
}

function fin() {
    var i = 0, iz = _func.length;
    for (; i < iz; ++i) {
        document.body.innerHTML += "<pre>" + _func[i] + "</pre>";
    }
}

// ---------------------------------------------
// utility
// 連続した数値を持つ配列を返す
function numary(size) { // @param Number: max length
                        // @return Array: [0, 1, 2, ... max-1]
    var rv = [], ri = -1, i = 0;

    for (; i < size; ++i) {
        rv[++ri] = i;
    }
    return rv;
}

// ノードを作成し<body>に追加する
function addNode(tagName, n) {
    for (var i = 0; i < n; ++i) {
        document.body.appendChild(document.createElement(tagName));
    }
}


